;	Skijump89 0.2b
;	All: Joni Valtanen
;	Last modified 15.8.2001

	include	"doorsos.h"						; general ROM calls
	include	"graphlib.h"						; graphics functions
	include	"userlib.h"						; general functions

	xdef		_main								; define program entry point
	xdef		_comment							; define program comment
	xdef		_ti89								; compile for TI-89
	xdef		_ti92plus							; compile for TI-92 Plus

_main:
	jsr		graphlib::clr_scr					; ruudun tyhjennys
	WriteStr	#10,#1,#1,title1
	WriteStr	#1,#17,#1,title2
	WriteStr	#5,#27,#1,title021
	WriteStr	#1,#50,#1,title0		
loop:	jsr		userlib::idle_loop					; call idle loop function
	cmp.b		#13,d0
	bne		loop
	bsr		ohjeet
	bsr		init
	bsr		maingame
	rts										;pois ohjelmasta siististi
ohjeet:
	jsr		graphlib::clr_scr					; ruudun tyhjennys
	WriteStr	#10,#1,#1,title10			
	WriteStr	#1,#11,#1,title11
	WriteStr	#1,#21,#1,title12
	WriteStr	#1,#31,#1,title125
	WriteStr	#1,#41,#1,title13
	WriteStr	#1,#51,#1,title14
	WriteStr	#1,#61,#1,title15
	WriteStr	#1,#81,#1,title3		
looop:
	jsr		userlib::idle_loop					; call idle loop function
	cmp.b		#13,d0
	bne		looop

	rts
init:
	move.b	#1,kuva
	move.b	#0,total
	move.b	#1,ponnari
	move.b	#0,power
	jsr		graphlib::clr_scr
	move.w	#20,spriteposx
	move.w	#20,spriteposy
	lea		$4c00,a0
	move.w	#20,d0							;itse hyppyri
	move.w	#28,d1
	move.w	#27,d2
	move.w	d1,d3
	jsr		graphlib::line
	move.w	#27,d0
	move.w	#28,d1
	move.w	#50,d2
	move.w	#51,d3
	jsr		graphlib::line
	move.w	#50,d0
	move.w	#51,d1
	move.w	#58,d2
	move.w	#51,d3
	jsr		graphlib::line

	move.w	#56,d0							;mki & tuki
	move.w	#51,d1
	move.w	#56,d2
	move.w	#55,d3
	jsr		graphlib::line
	move.w	#22,d0							
	move.w	#28,d1
	move.w	#22,d2
	move.w	#55,d3
	jsr		graphlib::line
	move.w	#20,d0
	move.w	#55,d1
	move.w	#66,d2
	move.w	#55,d3
	jsr		graphlib::line
	move.w	#66,d0						
	move.w	#55,d1
	move.w	#89,d2
	move.w	#78,d3
	jsr		graphlib::line
	move.w	#89,d0
	move.w	#78,d1
	move.w	#119,d2
	move.w	#78,d3
	jsr		graphlib::line
	WriteStr	#96,#10,#1,title17
	move.b	ennatys,j1
	move.w	#147,xxx
	bsr		enkka
	
	rts

maingame:
	lea.l		ukko1,a0
	bsr		ylaaija
	WriteStr	#1,#1,#1,title3		
l:	jsr		userlib::idle_loop					;venaa pappia
	cmp.b		#13,d0
	bne.b		l
	lea		store,a3
	movem.w	(a3)+,d0/d1/d2/d3					;storesta pois
	move.w	helpmem,d4
	cmp.w		#0,d4
	beq.w		end
	jsr		graphlib::memtoscr

	move.w	#0,th
	move.w	#1,dx
	move.w	#0,dy
	move.w	#4,counter1
	lea.l		ukko1,a0
	bsr		liikuta

	move.w	#1,dy
	move.w	#23,counter1
	lea.l		ukko2,a0
	bsr		liikuta

	move.w	#1,th
	move.w	#0,dy
	move.w	#8,counter1
	lea.l		ukko1,a0
	bsr		liikuta

	cmp.b		#0,power
	bne.w		hyppy
	jmp		kaatuminen
enter:
	jsr		userlib::idle_loop
	cmp.b		#13,d0			;enteri uuteen hyppyyn
	beq		aloitus
	rts
aloitus:
	bsr	init
	jmp	maingame

;annetaan:	deltax dx
;		deltay dy
;		counter counter >  0
;		a0:n spriten osoite
liikuta:
	move.b	#0,d5

	move.w	spriteposx,d0						;ottaa spriten alta ruutua ja tallettaa
	lsr.w		#3,d0
	sub.w		#1,d0
	move.w	#3,d2
	move.w	spriteposy,d1
	sub.w		#7,d1
	move.w	#17,d3
	lea.l		store,a3
	movem.w	d0/d1/d2/d3,(a3)					;storetetaan hetkeks
	jsr		graphlib::scrtomem
	move.w	d4,helpmem

loop2:
;	lea		store,a3

	btst.b	#0,kuva
	beq.b		kuva1

	movem.w	(a3)+,d0/d1/d2/d3					;storesta pois
	move.w	helpmem,d4
	cmp.w		#0,d4
	beq.w		end
	jsr		graphlib::memtoscr
	
	move.w	spriteposx,d0						;ottaa spriten alta ruutua ja tallettaa
	lsr.w		#3,d0
	sub.w		#1,d0
	move.w	#3,d2
	move.w	spriteposy,d1
	sub.w		#7,d1
	move.w	#17,d3
	lea		store,a3
	movem.w	d0/d1/d2/d3,(a3)					;storetus hetki
	jsr		graphlib::scrtomem
	move.w	d4,helpmem

kuva1:
	move.w	dx,d0
	add.w		d0,spriteposx
	move.w	dy,d1
	add.w		d1,spriteposy

	move.w	spriteposx,sprx
	move.w	spriteposy,spry
	bsr		handle					;handle namiskat

	btst.b	#0,kuva
	beq.b		kuva2

	move.w	spriteposx,d0				;sprite ruudulle a0:ssa kuva lea:lla
	move.w	spriteposy,d1
	jsr		graphlib::put_sprite

kuva2:
	move.w	#0,counter2
loop3:								;venaillaan 4000 kierrosta
	add.w		#1,counter2
	cmp.w		#9000,counter2
	bne.b		loop3

	btst.b	#0,kuva
	beq.b		kuvaa
	move.b	#0,kuva
kuvaa:
	add.b		#1,kuva
	add.l		#1,d5
	cmp.w		counter1,d5
	bne.w		loop2

	lea		store,a3
	movem.w	(a3)+,d0/d1/d2/d3					;storesta pois
	move.w	helpmem,d4
	cmp.w		#0,d4
	beq.w		end
	jsr		graphlib::memtoscr
end:	rts
ylaaija:
	move.w	spriteposx,d0						;ottaa spriten alta ruutua ja tallettaa
	lsr.w		#3,d0
	sub.w		#1,d0
	move.w	#3,d2
	move.w	spriteposy,d1
	sub.w		#7,d1
	move.w	#17,d3
	lea		store,a3
	movem.w	d0/d1/d2/d3,(a3)					;storetetaan hetkeks
	jsr		graphlib::scrtomem
	move.w	d4,helpmem

	move.w	spriteposx,d0				;sprite ruudulle a0:ssa kuva lea:lla
	move.w	spriteposy,d1
	jsr		graphlib::put_sprite
	rts
handle:
	cmp.w		#0,th						;jos hyppyrin nokalla, hyppyyn
	beq.w		yli

	move.b #%11111101,($600019)  ;keyboardin luku (enterin maski)
   	move.b #5,d0
  	wait:
   	nop
   	dbra.b d0,wait               ;odotellaan, ulos kun d0 on -1
   	move.b ($60001b),d0          ;luetaan nappisdata
   	btst.b #0,d0                 ;bit 4 is column 4
   	beq yli2                     ;bitti reset -> enter painettu 
yli:	rts
yli2:	addq.b	#1,power
	rts	

hyppy:
;	spry = spry+(1+1+1... powerin mr)

	move.b #%11111101,($600019)  ;keyboardin luku (enterin maski)
   	move.b #5,d0
  	waitb:
   	nop
   	dbra.b d0,waitb               ;odotellaan, ulos kun d0 on -1
   	move.b ($60001b),d0          ;luetaan nappisdata
   	btst.b #0,d0                 ;bit 4 is column 4
   	beq alas		               ;bitti reset -> enter painettu 

	lea		ukko3,a0
	move.w	#0,dy
	move.w	#1,d0
	add.b		power,d0
	move.w	d0,counter1
	bsr		liikuta

	move.w	#1,dy
	move.w	#1,counter1
	move.b	#2,ponnari
	bsr		koska_alas
	jmp		pisteet

koska_alas:
	bsr		liikuta
	move.b 	#%11111110,($600019)  ;keyboardin luku (enterin maski)
   	move.b 	#5,d0
waitc:
   	nop
   	dbra.b 	d0,waitc               ;odotellaan, ulos kun d0 on -1
   	move.b 	($60001b),d0          ;luetaan nappisdata
   	btst.b 	#2,d0                 ;bit 4 is column 4
   	beq		alastulo		        ;bitti reset -> enter painettu

	move.w	spriteposy,d4
	cmp.w		#71,d4
	beq.w		kaatu2
	jmp		koska_alas
alastulo:
	lea		ukko1,a0
	move.w	#1,dy
	move.w	#2,counter1
	bsr		liikuta

	lea		ukko2,a0
	move.w	#2,dy
	move.w	#1,dx
	move.w	#1,counter1
kiehkura:
	move.w	spriteposx,d6
	cmp.w		#89,d6
	bge.w		kaatu2
	move.w	spriteposy,d6
	cmp.w		#70,d6
	bge.w		kaatu2
	bsr		liikuta	
	move.w	spriteposy,d5
	move.w	spriteposx,xdownpos
	sub.w		#15,xdownpos
	cmp.w		xdownpos,d5
	bne.b		kiehkura

	move.w	spriteposx,xdownpos
	move.b	power,poweralas

	move.w	#1,dy
kiehkura2:
	move.w	spriteposx,d6	;Alas liun animaatio
	cmp.w		#89,d6		
	bge.b		kaatu2		
	move.w	spriteposy,d6	
	cmp.w		#70,d6		
	bge.b		kaatu2		

	bsr		liikuta
	move.w	spriteposy,d6
	cmp.w		#70,d6
	bne.b		kiehkura2
	lea		ukko1,a0
	move.w	#0,dy
	move.w	#15,counter1
	bsr		liikuta
	rts
kaatu2:
	move.b	#0,ponnari
	lea		ukko4,a0
	move.w	#0,dy
	bsr		liikuta
	rts
kaatuminen:
	move.b	#0,ponnari
	lea		ukko4,a0
alas:
	move.w	#1,dy
	move.w	#4,counter1
	bsr		liikuta
	jmp		pisteet

; Tasanteelle pystyss	
pystyst:
	move.b	#0,j3
	move.w	#2,d0
	jsr		userlib::random
	move.b	d0,t1			;eka tuomari	
	move.w	#2,d0
	jsr		userlib::random
	move.b	d0,t2				;2 tuomari	
	move.w	#2,d0
	jsr		userlib::random
	move.b	d0,t3				;3 tuomari	
	move.w	#2,d0
	jsr		userlib::random
	move.b	d0,t4			;4 tuomari	
	move.w	#2,d0
	jsr		userlib::random
	move.b	d0,t5			;5 tuomari	
	bsr		pointsit	
	jmp		kieppi

;pystyss loppuun
pystysl:
	move.b	poweralas,d5
	divu.b	#2,d5
	move.w	#3,d0
	jsr		userlib::random
	and.w		#1111,d0
	add.b		d0,d5
	move.b	d5,t1			;1 tuomari	

	move.b	poweralas,d5
	divu.b	#2,d5
	move.w	#3,d0
	jsr		userlib::random
	and.w		#1111,d0
	add.b		d0,d5
	move.b	d5,t2			;2 tuomari	

	move.b	poweralas,d5
	divu.b	#2,d5
	move.w	#3,d0
	jsr		userlib::random
	and.w		#1111,d0
	add.b		d0,d5
	move.b	d5,t3			;3 tuomari	

	move.b	poweralas,d5
	divu.b	#2,d5
	move.w	#3,d0
	jsr		userlib::random
	and.w		#1111,d0
	add.b		d0,d5
	move.b	d5,t4			;4 tuomari	

	move.b	poweralas,d5
	divu.b	#2,d5
	move.w	#3,d0
	jsr		userlib::random
	and.w		#1111,d0
	add.b		d0,d5
	move.b	d5,t5			;5 tuomari	


	bsr		pointsit	
	jmp		kieppi 

pointsit:
	move.b	t1,j1
	move.w	#7,xxx
	bsr		points2str
;toka tuomari
	move.b	t2,j1
	move.w	#31,xxx
	bsr		points2str
;kolmas tuomari
	move.b	t3,j1
	move.w	#55,xxx
	bsr		points2str
;neljs tuomari
	move.b	t4,j1
	move.w	#79,xxx
	bsr		points2str
;viides tuomari
	move.b	t5,j1
	move.w	#103,xxx
	bsr		points2str
;total
	move.b	t1,d6
	add.b		t2,d6
	add.b		t3,d6
	add.b		t4,d6
	add.b		t5,d6
	move.b	d6,total
	move.b	d6,j1
	move.w	#147,xxx
	bsr		points2str

	move.b	ennatys,d0
	and.l		#$ff,d0
	cmp.b		total,d0
	blt		uusenkka		
	rts

kaatus:
	move.b	#0,j3	
	move.b	#0,t1			;eka tuomari	
	move.b	#0,t2			;2 tuomari	
	move.b	#0,t3			;3 tuomari	
	move.b	#0,t4			;4 tuomari	
	move.b	#0,t5			;5 tuomari	
	bsr		pointsit	
	jmp		kieppi

pisteet:
	bsr		ylaaija
	movea.w	#$4c00,a4
silmu:
	move.b	#0,(a4)
	adda.w	#1,a4
	cmp.w		#$4d11,a4
	bne		silmu
	WriteStr	#1,#72,#1,title7	;your points	
	WriteStr	#1,#81,#1,title6	;tuomarit & TOTAL	
	WriteStr	#1,#1,#1,title4		;+ & ESC
	WriteStr	#1,#9,#1,title5		
	cmp.b		#1,ponnari
	beq.w		pystyst
	cmp.b		#2,ponnari
	beq.w		pystysl
	cmp.b		#0,ponnari
	beq.w		kaatus
kieppi:
	jsr		userlib::idle_loop
	cmp.b		#43,d0			;+ uuteen hyppyyn
	beq.w		aloitus
	cmp.b		#264,d0			;ESC pois
	beq.w		lopetus
	jmp		kieppi

;xxx = tekstin x-koord
;strpoint = numero stringgin
;j1 = pointsit
;j2 = kymmenet
points2str:
	move.w	#90,yyy
	bsr 		jaaaaa
	rts
enkka:
	move.w	#10,yyy
jaaaaa:
	move.b	j1,d1
	divu.b	#10,d1
	move.b	d1,j2
	moveq.b	#0,d5
	move.b	j1,d1

kiepulaa:
	sub.b		#10,d1
	add.b		#1,d5
	cmp.b		j2,d5
	bne.b		kiepulaa

	move.l	#48,d2
	add.b		d1,d2
	move.b	d2,strpoint
	WriteStr	xxx,yyy,#1,strpoint		
								
	move.l	#48,d2
	add.b		j2,d2
	move.b	d2,strpoint
	move.w	xxx,d3
	sub.w		#6,d3
	move.w	d3,xxx
	WriteStr	xxx,yyy,#1,strpoint
lopetus:
	rts
uusenkka:
	WriteStr	#1,#18,#1,title16
	move.b	total,ennatys			
	rts
ukko1:		dc.w		8						;ukko sprite1
			dc.w		1
			dc.b		%00010000
			dc.b		%00111000
			dc.b		%00010000
			dc.b		%00111000
			dc.b		%01111000
			dc.b		%00110000
			dc.b		%00110001
			dc.b		%11111110

ukko2:		dc.w		8						;ukko sprite2
			dc.w		1
			dc.b		%00000100
			dc.b		%00001110
			dc.b		%00011100
			dc.b		%00111000
			dc.b		%10111000
			dc.b		%01110000
			dc.b		%00110000
			dc.b		%00011110

ukko3:		dc.w		8						;ukko sprite3
			dc.w		1
			dc.b		%00000100
			dc.b		%00001110
			dc.b		%00001100
			dc.b		%00011001
			dc.b		%00011011
			dc.b		%00111110
			dc.b		%00110000
			dc.b		%11000000

ukko4:		dc.w		8						;ukko sprite4 kaatuminen
			dc.w		1
			dc.b		%00010000
			dc.b		%00111000
			dc.b		%00010000
			dc.b		%11011001
			dc.b		%00111011
			dc.b		%00111110
			dc.b		%00110100
			dc.b		%11000011


spriteposx		dc.w		0
spriteposy		dc.w		0
sprx			dc.w		0
spry			dc.w		0
helpmem		dc.w		0
dx			dc.w		0
dy			dc.w		0
counter1		dc.w		0
counter2		dc.w		0
th			dc.w		0
power			dc.b		0
poweralas		dc.b		0
ponnari		dc.b		0
j1			dc.b		0
j2			dc.b		0
j3			dc.b		0
kokeilu		dc.b		0
t1			dc.b		0
t2			dc.b		0
t3			dc.b		0
t4			dc.b		0
t5			dc.b		0
total			dc.b		0
seedp			dc.b		0
store			dc.l		0
xdownpos		dc.l 		0
strpoint		dc.b		0
xxx			dc.w		0
yyy			dc.w		0
ennatys		dc.b		0
kuva			dc.b		0

title0		dc.b		"Press enter to help",0
title1		dc.b		"SKIJUMP89 0.2b",0
title2		dc.b		"All work: Joni Valtanen",0
title021		dc.b		"at summer 2001",0
title3		dc.b		"Press enter to jump",0
title4		dc.b		"Press + to jump again or",0
title5		dc.b		"ESC to QUIT",0
title6		dc.b		"J1  J2  J3  J4  J5   Total",0
title7		dc.b		"Your points:",0
title8		dc.b		"0   0   0   0   0    0",0
title9		dc.b		"1   1   1   1   1    5",0
title10		dc.b		" First push once enter",0
title11		dc.b		"then on the flat hold",0
title12		dc.b		"enter down and let it free",0
title125		dc.b		"when you jump. On the air",0
title13		dc.b		"you should hold enter to",0
title14		dc.b		"get stylepoints. Finally",0
title15		dc.b		"push arrowdown to land.",0
title16		dc.b		"New record!!",0
title17		dc.b		"RECORD:",0
_comment		dc.b		"Skijump89, All: Joni Valtanen",0		; define comment
			end
